!DIR$ FIXEDFORMLINESIZE:132
      subroutine make_Mode(Mode)
      use dblocks
      use formats
      use values
      implicit none
      integer*4, intent(out) :: Mode

      if     ((fkx .eq. rz) .and. (fky .eq. rz)) then

         if     (any(Pol .eq. Pol_x)) then
            Mode =  1
            write(6,f2) '>  MakeMode : Prop: Z, Pol: X,           Mode=', Mode
         else if(any(Pol .eq. Pol_y)) then
            Mode =  2
            write(6,f2) '>  MakeMode : Prop: Z, Pol: Y,           Mode=', Mode
         else
            write(6,f1) '>  MakeMode : Ambiguous polarization (Ref.Point A); exiting'
            Mode = -1
            return
         end if
            
      else if((fkx .ne. rz) .and. (fky .eq. rz)) then

         if     (any(Pol .eq. Pol_y ) .or. any(Pol .eq. Pol_s)) then
            Mode =  3
            write(6,f2) '>  MakeMode : Prop: XZ, Pol: Y  (s-pol), Mode=', Mode
         else if(any(Pol .eq. Pol_xz) .or. any(Pol .eq. Pol_p)) then
            Mode =  4
            write(6,f2) '>  MakeMode : Prop: XZ, Pol: XZ (p-pol), Mode=', Mode
         else
            write(6,f1) '>  MakeMode : Ambiguous polarization (Ref.Point B); exiting'
            Mode = -2
            return
         end if

      else if((fkx .eq. rz) .and. (fky .ne. rz)) then

         if     (any(Pol .eq. Pol_x ) .or. any(Pol .eq. Pol_s)) then
            Mode =  5
            write(6,f2) '>  MakeMode : Prop: YZ, Pol: X  (s-pol), Mode=', Mode
         else if(any(Pol .eq. Pol_yz) .or. any(Pol .eq. Pol_p)) then
            Mode =  6
            write(6,f2) '>  MakeMode : Prop: YZ, Pol: YZ (p-pol), Mode=', Mode
         else
            write(6,f1) '>  MakeMode : Ambiguous polarization (Ref.Point B); exiting'
            Mode = -3
            return
         end if

      else if((fkx .ne. rz) .and. (fky .ne. rz)) then

         Mode =  7
         write(6,f2) '>  MakeMode : General Prop/Pol           Mode=', Mode

      else

         write(6,f1) '>  MakeMode : Ambiguous polarization/propagation combination (Ref.Point C); exiting'
         Mode = -4
         return

      end if

      return
      end
     
