!DIR$ FIXEDFORMLINESIZE:132
      pure subroutine reduce_toFBZ(cqz, flag)
      use dblocks
      implicit none
      complex*16, intent(inout) :: cqz
      logical*4 , intent(out)   :: flag

      real*8    x, y
      integer*4 nq

      x  = dreal(cqz)
      y  = dimag(cqz)
      nq = floor((x+fbz) / rlv)
      x  = x - nq*rlv
      cqz = x + cu*y

      if(iabs(nq) .gt. nqth) then
         flag = .false.
      else
         flag = .true.
      end if

      return
      end
